/*
 * Copyright (C) 1994, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
 * the contents of this file may not be disclosed to third parties, copied or
 * duplicated in any form, in whole or in part, without the prior written
 * permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
 * and Computer Software clause at DFARS 252.227-7013, and/or in similar or
 * successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
 * rights reserved under the Copyright Laws of the United States.
 */
/*
 *  callbacks.h - defines, includes and externs for callbacks.
 *
 *
 */

#include <Xm/Xm.h>
#include <Xm/BulletinB.h> 
#include <vl/vl.h>
#include <vl/dev_ev1.h>

#define YMIN_VAL 0 
#define YMAX_VAL 255  
#define UMIN_VAL -226 
#define UMAX_VAL 226  
#define VMIN_VAL -179 
#define VMAX_VAL 179 
#define DO_U 1
#define DO_V 2
#define DO_DETAIL 3
#define DO_Y 4
#define DO_FGOP 5
#define DO_ALL 6

void extern docleanup();
void extern minmaxtorangeval();
void extern rangevaltominmax();

extern float Version_number;
extern VLNode src_scr;
extern VLNode drn_scr;
extern VLNode src_vid;
extern VLNode blend_node;
extern VLNode mydev_node;
extern Boolean gfxonvid; 
extern VLServer vlSvr; 
extern VLPath   vlPath;

extern Widget AppShell; /* so i can recreate a widget's shell */
extern Widget Shell001; /* shell for chromabboard */
extern Widget Shell002; /* shell for lumabboard */
extern Widget Shell003; /* shell for switchbboard */
extern Widget ChromaBBoard; /* pop up's bboard widget */
extern Widget LumaBBoard; /* pop up's bboard widget */
extern Widget SwitchBBoard; /* pop up's bboard widget */
extern Widget CreatechromaBBoard(); /* bboard's create fn */
extern Widget CreatelumaBBoard();   /* bboard's create fn */
extern Widget CreateswitchBBoard(); /* bboard's create fn */
extern Widget CreatechromaShell(); /*  shell's create fn */
extern Widget CreatelumaShell(); /*  shell's create fn */
extern Widget CreateswitchShell(); /*  shell's create fn */

extern Boolean Urangelock;	/*  slider lock boolean */
extern Boolean Vrangelock;	/*  slider lock boolean */
extern Boolean Yrangelock;	/*  slider lock boolean */
extern int Urangelockval;	/*  slider lock boolean */
extern int Vrangelockval;	/*  slider lock boolean */
extern int Yrangelockval;	/*  slider lock boolean */
extern Boolean Automanualswitch;/*  auto vs. manual switch boolean */
extern int ev1num;	        /*  device number for ev1 */

